package org.infinispan.notifications.cachelistener;

import org.infinispan.Cache;
import org.infinispan.config.Configuration;
import org.infinispan.lock.IsolationLevel;
import org.infinispan.manager.CacheManager;
import org.infinispan.test.TestingUtil;
import org.infinispan.test.fwk.TestCacheManagerFactory;
import org.infinispan.transaction.DummyTransactionManagerLookup;
import org.testng.Assert;
import org.testng.annotations.AfterTest;
import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;

@Test(groups = "functional", testName = "notifications.cachelistener.AnotherCacheNotifierTest")
public class AnotherCacheNotifierTest {
	private Cache<Object, Object> cache;

	@BeforeMethod(alwaysRun = true)
	public void setUp() throws Exception {
		Configuration c = new Configuration();
		c.setCacheMode(Configuration.CacheMode.LOCAL);
		c.setIsolationLevel(IsolationLevel.REPEATABLE_READ);
		c.setTransactionManagerLookupClass(DummyTransactionManagerLookup.class
				.getName());
		CacheManager cm = TestCacheManagerFactory.createCacheManager(c);
		cache = cm.getCache();
		
	}

	@AfterTest
	public void destroyManager() {
		TestingUtil.killCacheManagers(cache.getCacheManager());
	}

	public void testCreationWithAnotherMockListener() throws Exception {
		AnotherMockCacheListener listener = new AnotherMockCacheListener();
		cache.addListener(listener);
		cache.put("key", new String("Mock!"));
		Assert.assertEquals(listener.events.size(), 4);
	}
}
